package cz.cuni.mff.d3s.stdynpor.examples.arrays;

// threads accessing the same field of array elements with an object type
// elements indexed with method parameters (constants)
// different array elements accessed in both concurrent threads

public class ARR10
{
    public static void main(String[] args) {
		Data[] buf = new Data[4];
		for (int i = 0; i < buf.length; i++) buf[i] = new Data(i);

        Thread t1 = new ReaderThread(buf);
        Thread t2 = new WriterThread(buf);

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class WriterThread extends Thread 
	{
    	private Data[] buffer;

	    public WriterThread(Data[] buf) {
    	    this.buffer = buf;
    	}

    	public void run() {
			update(0, 5);
			update(1, 8);
		}

		private void update(int idx, int nv)
		{
			buffer[idx].val = nv;
    	}
	}

	static class ReaderThread extends Thread 
	{ 
    	private Data[] buffer;

    	public ReaderThread(Data[] buf) {
        	this.buffer = buf;
	    }

    	public void run() {
	        System.out.println("buffer[2] = " + load(2));
	        System.out.println("buffer[3] = " + load(3)); 
		}

		private int load(int idx)
		{
			return buffer[idx].val;
		}	
	}
	
	static class Data
	{
		public int id;
		public int val;

		public Data(int id)
		{
			this.id = id;
			this.val = 0;
		}
	}
}

