package cz.cuni.mff.d3s.stdynpor.examples.arrays;

// threads accessing various elements of the shared multi-dimensional array
// indexes defined as variable expressions (object fields, constants)

public class ARR11
{
    public static void main(String[] args) {
		int[][] matrix = new int[5][5];

        Thread t1 = new ReaderThread(matrix, 1);
        Thread t2 = new WriterThread(matrix, 2);

        t1.start();
        t2.start();
        
        try {
            t1.join();
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class WriterThread extends Thread 
	{
    	private int[][] matrix;
		private int id;

	    public WriterThread(int[][] matrix, int id) {
    	    this.matrix = matrix;
			this.id = id;
    	}

    	public void run() {
			matrix[id-1][0] = 2;
			matrix[id+2][1] = 4;
			matrix[2][2] = 6;
    	}
	}

	static class ReaderThread extends Thread 
	{ 
    	private int[][] matrix;
		private int id;

    	public ReaderThread(int[][] matrix, int id) {
        	this.matrix = matrix;
			this.id = id;
	    }

    	public void run() {
			int v1 = matrix[2][2];
	        System.out.println("matrix[2][2] = " + v1);
			int v2 = matrix[id-1][3];
	        System.out.println("matrix[1][3] = " + v2);
			int v3 = matrix[id+2][4];
	        System.out.println("matrix[4][4] = " + v3);   
    	}
	}
}

