package cz.cuni.mff.d3s.stdynpor.examples.arrays;

// array index is a local variable computed using arithmetic expression that involves a method parameter

public class ARR14
{
    public static void main(String[] args) {
		int[] buf = new int[]{1,2,3,4,5,6};

        Thread t1 = new ReaderThread(buf);
        Thread t2 = new WriterThread(buf);

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class WriterThread extends Thread 
	{
    	private int[] buffer;

	    public WriterThread(int[] buf) {
    	    this.buffer = buf;
    	}

    	public void run() {
    		update(1, 5);
    		update(3, 8);
		}
		
		private void update(int p, int nv)
		{
			buffer[p-1] = nv;
		}
	}

	static class ReaderThread extends Thread 
	{ 
    	private int[] buffer;

    	public ReaderThread(int[] buf) {
        	this.buffer = buf;
	    }

    	public void run() {
   			System.out.println("buffer[1] = " + buffer[1]);
   			System.out.println("buffer[2] = " + load(3));
		}
		
		private int load(int p)
		{
			return buffer[p-1];
		}	
	}
}

