package cz.cuni.mff.d3s.stdynpor.examples.arrays;

// array index is a method parameter whose value is derived from an object field (using arithmetic expression)

public class ARR16
{
    public static void main(String[] args) {
		int[] buf = new int[]{1,2,3,4,5,6};

        Thread t1 = new ReaderThread(buf);
        Thread t2 = new WriterThread(buf);

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class WriterThread extends Thread 
	{
    	private int[] buffer;
    	private int wpos;

	    public WriterThread(int[] buf) {
    	    this.buffer = buf;
    	    this.wpos = 0;
    	}

    	public void run() {
    		update(this.wpos, 5);
			this.wpos += 1;
    		update(this.wpos + 1, 10);
		}
		
		private void update(int p, int nv)
		{
			buffer[p] = nv;
		}
	}

	static class ReaderThread extends Thread 
	{ 
    	private int[] buffer;
    	private int rpos;

    	public ReaderThread(int[] buf) {
        	this.buffer = buf;
        	this.rpos = 1;
	    }

    	public void run() {
   			System.out.println("buffer[0] = " + load(this.rpos - 1));
   			System.out.println("buffer[3] = " + load(this.rpos + 2));
		}
		
		private int load(int p)
		{
			return buffer[p];
		}	
	}
}

