package cz.cuni.mff.d3s.stdynpor.examples.arrays;

// array index is a method parameter whose value is derived from a local variable (loop counter)

public class ARR17
{
    public static void main(String[] args) {
		int[] buf = new int[]{1,2,3,4,5,6};

        Thread t1 = new ReaderThread(buf);
        Thread t2 = new WriterThread(buf);

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class WriterThread extends Thread 
	{
    	private int[] buffer;

	    public WriterThread(int[] buf) {
    	    this.buffer = buf;
    	}

    	public void run() {
    		for (int i = 0; i < 3; i++)	{
    			update(i+1, i+5);
    		}
		}
		
		private void update(int p, int nv)
		{
			buffer[p] = nv;
		}
	}

	static class ReaderThread extends Thread 
	{ 
    	private int[] buffer;

    	public ReaderThread(int[] buf) {
        	this.buffer = buf;
	    }

    	public void run() {
    		for (int j = 5; j >= 2; j--) { 
    			System.out.println("buffer["+(j-1)+"] = " + load(j-1));
    		}
		}
		
		private int load(int p)
		{
			return buffer[p];
		}	
	}
}

