package cz.cuni.mff.d3s.stdynpor.examples.arrays;

// array index is a method parameter whose value is derived from the array length

public class ARR18
{
    public static void main(String[] args) {
		int[] buf = new int[]{1,2,3,4,5,6};

        Thread t1 = new ReaderThread(buf);
        Thread t2 = new WriterThread(buf);

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class WriterThread extends Thread 
	{
    	private int[] buffer;

	    public WriterThread(int[] buf) {
    	    this.buffer = buf;
    	}

    	public void run() {
    		update(buffer.length-4, 5);
    		update(buffer.length-2, 10);
		}
		
		private void update(int p, int nv)
		{
			buffer[p] = nv;
		}
	}

	static class ReaderThread extends Thread 
	{ 
    	private int[] buffer;

    	public ReaderThread(int[] buf) {
        	this.buffer = buf;
	    }

    	public void run() {
   			System.out.println("buffer[3] = " + load(buffer.length/2));
   			System.out.println("buffer[4] = " + load(buffer.length-2));
		}
		
		private int load(int p)
		{
			return buffer[p];
		}	
	}
}

