package cz.cuni.mff.d3s.stdynpor.examples.arrays;

// array index is a local variable whose value is derived using arithmetic expression (that involves array length and method parameters)

public class ARR19
{
    public static void main(String[] args) {
		int[] buf = new int[]{1,2,3,4,5,6};

        Thread t1 = new ReaderThread(buf);
        Thread t2 = new WriterThread(buf);

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class WriterThread extends Thread 
	{
    	private int[] buffer;

	    public WriterThread(int[] buf) {
    	    this.buffer = buf;
    	}

    	public void run() {
    		update(1, 5);
    		update(2, 10);
		}
		
		private void update(int p, int nv)
		{
			int i = computeIndex(p);
			buffer[i] = nv;
		}
		
		private int computeIndex(int p)
		{
			return buffer.length - p;
		}
	}

	static class ReaderThread extends Thread 
	{ 
    	private int[] buffer;

    	public ReaderThread(int[] buf) {
        	this.buffer = buf;
	    }

    	public void run() {
   			System.out.println("buffer[3] = " + load(2));
   			System.out.println("buffer[5] = " + load(0));
		}
		
		private int load(int p)
		{
			int i = buffer.length - p - 1;
			return buffer[i];
		}	
	}
}

