package cz.cuni.mff.d3s.stdynpor.examples.arrays;

// array index is a local variable whose value is derived using arithmetic expression (that involves object fields and method parameters)

public class ARR20
{
    public static void main(String[] args) {
		int[] buf = new int[]{1,2,3,4,5,6};

        Thread t1 = new ReaderThread(buf);
        Thread t2 = new WriterThread(buf);

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class WriterThread extends Thread 
	{
    	private int[] buffer;
    	private int wpos;

	    public WriterThread(int[] buf) {
    	    this.buffer = buf;
    	    this.wpos = 0;
    	}

    	public void run() {
    		update(1, 5);
    		update(2, 10);
		}
		
		private void update(int p, int nv)
		{
			int i = computeIndex(p);
			buffer[i] = nv;
			this.wpos += 1;
		}
		
		private int computeIndex(int p)
		{
			return this.wpos + p;
		}
	}

	static class ReaderThread extends Thread 
	{ 
    	private int[] buffer;
    	private int rpos;

    	public ReaderThread(int[] buf) {
        	this.buffer = buf;
        	this.rpos = 0;
	    }

    	public void run() {
   			System.out.println("buffer[1] = " + buffer[1]);
   			this.rpos += 1;
   			System.out.println("buffer[2] = " + load(1));
		}
		
		private int load(int p)
		{
			int i = this.rpos + p;
			return buffer[i];
		}	
	}
}

