package cz.cuni.mff.d3s.stdynpor.examples.dynpor;

// unsynchronized access to different objects

// T1: read X ; read Y ; read Z
// T2: write X ; write Z ; write Y

public class DPOR01 
{
    public static int x = 0;
    public static int y = 0;
    public static int z = 0;
    
	public static void main(String[] args) 
	{
		Thread t1 = new ReaderThread();
		Thread t2 = new WriterThread();
        
        t1.start();
        t2.start();
        
        try {
            t1.join();
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class DataX { public static int value = 0; }
	static class DataY { public static int value = 0; }
	static class DataZ { public static int value = 0; }

	static class ReaderThread extends Thread 
	{
	    public void run() {
    	    int tmpX = DataX.value;
        	int tmpY = DataY.value;
	        int tmpZ = DataZ.value;

      	  	System.out.println("x = " + tmpX + ", y = " + tmpY + ", z = " + tmpZ);
    	}
	}

	static class WriterThread extends Thread 
	{
	    public void run() {
    	    DataX.value = 1;
        	DataZ.value = 1;
	        DataY.value = 1;
    	}
	}
}

