package cz.cuni.mff.d3s.stdynpor.examples.fields;


public class FLD04
{
	static interface A
	{
		int getNum();
		void setNum(int n);
	}

	static class B implements A
	{
		protected int num;

		public int getNum() 
		{ 
			return num; 
		}

		public void setNum(int n) 
		{ 
			this.num = n; 
		}
	}

	public static void main(String[] args) 
	{
		A a = new B();
		
		Thread t1 = new ReaderThread(a);
		Thread t2 = new WriterThread(a);
		
		t1.start();
		t2.start();
		
		try 
		{
			t1.join();
			t2.join();
		} 
		catch (InterruptedException e) 
		{
			e.printStackTrace();
		}
	}

	static class ReaderThread extends Thread 
	{
		private A a;
		
		public ReaderThread(A a) 
		{
			this.a = a;
		}
		
		public void run() 
		{
			System.out.println("a.num = " + a.getNum());
		}
	}

	static class WriterThread extends Thread 
	{
		private A a;
		
		public WriterThread(A a) 
		{
			this.a = a;
		}
		
		public void run() 
		{
			a.setNum(10);
		}
	}
}

