package cz.cuni.mff.d3s.stdynpor.examples.fields;

import java.util.List;
import java.util.LinkedList;
import java.util.Map;
import java.util.HashMap;


// testing concurrency
public class FLD05
{
	public static void main(String[] args)
	{
		Company c = new Company();

		c.addEmployee(1, "prvni");
		c.addEmployee(2, "druhy");

		FirstWorker w1 = new FirstWorker(c);
		SecondWorker w2 = new SecondWorker(c);

		w1.start();
		w2.start();

		try
		{
			w1.join();
			w2.join();
		}
		catch (Exception ex) {}
	}

	static class FirstWorker extends Thread
	{
		private Company c;

		public FirstWorker(Company c)
		{
			this.c = c;
		}

		public void run()
		{
			c.setEmployeeSalary(2, 100);

			c.printEmployeeNames();

			c.setEmployeeSalary(3, 80);
		}
	}

	static class SecondWorker extends Thread
	{
		private Company c;

		public SecondWorker(Company c)
		{
			this.c = c;
		}

		public void run()
		{
			c.printEmployeeNames();

			c.addEmployee(3, "treti");
			
			c.setEmployeeSalary(1, 50);
		}
	}

	static class Company
	{
		public Map<Integer, Person> employees;

		public Company()
		{
			employees = new HashMap<Integer, Person>();
		}

		public void addEmployee(int id, String name)
		{
			Person p = new Person(id, name);
			employees.put(id, p);
		}
	
		public void printEmployeeNames()
		{
			for (Person p : employees.values()) System.out.println(p.name);
		}
	
		public void setEmployeeSalary(int id, int newSalary)
		{
			Person p = employees.get(id);
		
			if (p != null) p.salary = newSalary;
		}
	}
	
	static class Person
	{
		public int id;
		public String name;
		public int salary;

		public Person(int i, String s)
		{
			id = i;
			name = s;
		}
	} 
}

