package cz.cuni.mff.d3s.stdynpor.examples.fields;

import java.util.List;
import java.util.LinkedList;
import java.util.Map;
import java.util.HashMap;


// testing elements
public class FLD06
{
	public static void main(String[] args)
	{
		Company c = new Company();

		c.addEmployee(1, "prvni");
		c.addEmployee(2, "druhy");
		c.addEmployee(3, "treti");
		c.addEmployee(4, "ctvrty");
		c.addEmployee(5, "paty");

		FirstWorker w1 = new FirstWorker(c);
		SecondWorker w2 = new SecondWorker(c);

		w1.start();
		w2.start();

		try
		{
			w1.join();
			w2.join();
		}
		catch (Exception ex) {}
	}

	static class FirstWorker extends Thread
	{
		private Company c;

		public FirstWorker(Company c)
		{
			this.c = c;
		}

		public void run()
		{
			c.setEmployeeSalary(1, 100);

			System.out.println(c.getEmployeeName(3));

			c.setEmployeeSalary(3, 80);
			
			System.out.println(c.getEmployeeName(5));
			
			System.out.println(c.getEmployeeSalary(1));
		}
	}

	static class SecondWorker extends Thread
	{
		private Company c;

		public SecondWorker(Company c)
		{
			this.c = c;
		}

		public void run()
		{
			c.addEmployee(6, "sesty");
			
			c.setEmployeeSalary(2, 50);
			
			System.out.println(c.getEmployeeName(4));
			
			c.setEmployeeSalary(6, 150);
			
			c.setEmployeeName(4, "fourth");
		}
	}

	static class Company
	{
		public Map<Integer, Person> employees;

		public Company()
		{
			employees = new HashMap<Integer, Person>();
		}

		public void addEmployee(int id, String name)
		{
			Person p = new Person(id, name);
			employees.put(id, p);
		}
	
		public String getEmployeeName(int id)
		{
			Person p = employees.get(id);
		
			if (p != null) return p.name;
			else return null;
		}
	
		public void setEmployeeName(int id, String newName)
		{
			Person p = employees.get(id);
		
			if (p != null) p.name = newName;
		}
	
		public int getEmployeeSalary(int id)
		{
			Person p = employees.get(id);
		
			if (p != null) return p.salary;
			else return 0;
		}
	
		public void setEmployeeSalary(int id, int newSalary)
		{
			Person p = employees.get(id);
		
			if (p != null) p.salary = newSalary;
		}
	}
 
	static class Person
	{
		public int id;
		public String name;
		public int salary;

		public Person(int i, String s)
		{
			id = i;
			name = s;
		}
	}
}
