package cz.cuni.mff.d3s.stdynpor.examples.fields;

import java.util.List;
import java.util.LinkedList;
import java.util.Map;
import java.util.HashMap;
 

// testing pointer analysis context
public class FLD07
{
	public static void main(String[] args)
	{
		Company c1 = new Company();
		c1.addEmployee(1, "prvni");
		c1.addEmployee(2, "druhy");
		
		Company c2 = new Company();
		c2.addEmployee(1, "prvni");
		c2.addEmployee(2, "druhy");

		FirstWorker w1 = new FirstWorker(c1);
		SecondWorker w2 = new SecondWorker(c2);

		w1.start();
		w2.start();

		try
		{
			w1.join();
			w2.join();
		}
		catch (Exception ex) {}
	}

	static class FirstWorker extends Thread
	{
		private Company c;

		public FirstWorker(Company c)
		{
			this.c = c;
		}

		public void run()
		{
			c.printEmployeeNames();
			
			doSmth1();
		}
		
		public void doSmth1()
		{
			c.setEmployeeSalary(2, 100);
			
			c.addEmployee(3, "treti");
			
			Person p = new Person(4, "ctvrty");
			c.addEmployee(p);
			
			doSmth();		
		}
		
		public void doSmth()
		{
			c.setEmployeeSalary(1, 80);

			Person p = new Person(5, "paty");
			c.addEmployee(p);
			
			c.printEmployeeNames();
		}
	}

	static class SecondWorker extends Thread
	{
		private Company c;

		public SecondWorker(Company c)
		{
			this.c = c;
		}

		public void run()
		{
			c.printEmployeeNames();
			
			doSmth2();
		}
		
		public void doSmth2()
		{
			c.setEmployeeSalary(1, 90);
			
			c.addEmployee(6, "sesty");
			
			Person p = new Person(7, "sedmy");
			c.addEmployee(p);
			
			doSmth();			
		}
		
		public void doSmth()
		{
			c.setEmployeeSalary(2, 120);

			Person p = new Person(8, "osmy");
			c.addEmployee(p);
			
			c.printEmployeeNames();
		}
	}

	static class Company
	{
		public Map<Integer, Person> employees;

		public Company()
		{
			employees = new HashMap<Integer, Person>();
		}

		public void addEmployee(int id, String name)
		{
			Person p = new Person(id, name);
			employees.put(id, p);
		}
	
		public void addEmployee(Person p)
		{
			employees.put(p.id, p);
		}

		public void printEmployeeNames()
		{
			for (Person p : employees.values()) System.out.println(p.name);
		}
	
		public void setEmployeeSalary(int id, int newSalary)
		{
			Person p = employees.get(id);
		
			if (p != null) p.salary = newSalary;
		}
	}
 
	static class Person
	{
		public int id;
		public String name;
		public int salary;

		public Person(int i, String s)
		{
			id = i;
			name = s;
		}
	}
}
