package cz.cuni.mff.d3s.stdynpor.examples.fields;

import java.util.List;
import java.util.ArrayList;


// running example from the journal paper
public class FLD08
{
	public static void main(String[] args)
	{
		Company cmp = new Company();
		
		cmp.addEmployee("john", 100);
		
		cmp.addEmployee(new Employee("paul", 120));
	
		FirstWorker w1 = new FirstWorker(cmp);
		SecondWorker w2 = new SecondWorker(cmp);
		
		w1.start();
		w2.start();
		
		try
		{
			w1.join();
			w2.join();
		}
		catch (Exception ex) {}
	}
	
	static class Employee
	{
		String name;
		Integer salary;
		Long index;
		
		Employee() {}
		
		Employee(String name, Integer salary) 
		{
			this.name = name;
			this.salary = salary;
		}
	}

	static class Company 
	{
		List<Employee> employees;
		
		Company() 
		{
			employees = new ArrayList<Employee>();
		}
		
		void addEmployee(String name, Integer salary) 
		{
			Employee emp = new Employee(name, salary);
			emp.index = (long) employees.size();
			employees.add(emp);
		}
		
		void addEmployee(Employee emp) 
		{
			emp.index = (long) employees.size();
			employees.add(emp);
		}
		
		void printEmployees() 
		{
			for (Employee e : employees) 
			{
				System.out.println(e.index + ":" + e.name);
			}
		}
		
		void setEmployeeSalary(Long id, Integer nSalary) 
		{
			for (Employee e : employees) 
			{
				if (e.index.equals(id)) e.salary = nSalary;
			}
		}
		
		Integer getEmployeeSalary(String eName) 
		{
			for (Employee e : employees) 
			{
				if (e.name.equals(eName)) return e.salary;
			}
			
			return null;
		}
	}

	static class FirstWorker extends Thread 
	{
		private Company cmp;
		
		FirstWorker(Company cmp) 
		{
			this.cmp = cmp;
		}
		
		public void run() 
		{
			cmp.addEmployee("david", 115);
			cmp.printEmployees();
			Integer r = cmp.getEmployeeSalary("john");
			cmp.setEmployeeSalary(1L, 150);
			cmp.printEmployees();
		}
	}
	
	static class SecondWorker extends Thread 
	{
		private Company cmp;
		
		SecondWorker(Company cmp) 
		{
			this.cmp = cmp;
		}
		
		public void run() 
		{
			Integer r = cmp.getEmployeeSalary("paul");
			cmp.addEmployee("mark", 80);
			cmp.printEmployees();
		}
	}
}
