package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

// T1: wait L ; write X
// T2: read X ; notify L

public class HBF02 
{
    public static int x = 0;
    
    public static void main(String[] args) {
        Object lock = new Object();
        
        Thread t1 = new WriterThread(lock);
        Thread t2 = new ReaderThread(lock);

        t1.start();        
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class ReaderThread extends Thread 
	{
		private final Object lock;

    	public ReaderThread(Object lock) {
        	this.lock = lock;
	    }

    	public void run() {
       	    System.out.println("x = " + HBF02.x);
            synchronized (lock) {
                lock.notifyAll();
            }
    	}
    }

	static class WriterThread extends Thread 
	{
    	private final Object lock;

        public WriterThread(Object lock) {
        	this.lock = lock;
	    }

    	public void run() {
			synchronized (lock) {
		        try {
    		        lock.wait();
	    	    } catch (InterruptedException e) {}
			}
      	    HBF02.x = 1;
    	}    
	}
}

