package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

// T1: write X ; notify L1
// T2: notify L2
// T3: wait L1 ; read X

// Note: L1 is not aliased with L2

public class HBF03 
{
    public static int x = 0;
    
    public static void main(String[] args) {
        Object l1 = new Object();
        Object l2 = new Object();
        
        Thread t1 = new WriterThread(l1);
        Thread t2 = new NotifyThread(l2);
        Thread t3 = new ReaderThread(l1);

        t1.start();
        t2.start();
        t3.start();
        
        try {
            t1.join(); 
            t3.join();
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class WriterThread extends Thread 
	{
    	private final Object lock1;

	    public WriterThread(Object lock) {
    	    this.lock1 = lock;
	    }

    	public void run() {
        	HBF03.x = 1;
	        synchronized (lock1) {
    	        lock1.notifyAll();
        	}
    	}
	}

	static class NotifyThread extends Thread 
	{    
    	private final Object lock2;

	    public NotifyThread(Object lock) {
        	this.lock2 = lock;
	    }
    
    	public void run() {
            synchronized (lock2) {
                lock2.notifyAll();
            }
    	}
	}

	static class ReaderThread extends Thread 
	{
    	private final Object lock1;
	    
	    public ReaderThread(Object lock) {
        	this.lock1 = lock;
	    }

    	public void run() {
			synchronized (lock1) {
		        try {
    		        lock1.wait();
	    	    } catch (InterruptedException e) {}
			}
       	    System.out.println("x = " + HBF03.x);
    	}    
	}
}

