package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

// T1: write X ; notify L1
// T2: notify L1
// T3: wait L1 ; read X

public class HBF04 
{
    public static int x = 0;
    
    public static void main(String[] args) {
        Object lock = new Object();
        
        Thread t1 = new WriterThread(lock);
        Thread t2 = new NotifyThread(lock);
        Thread t3 = new ReaderThread(lock);

        t1.start();
        t2.start();
        t3.start();
        
        try {
            t1.join(); 
            t3.join();
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class WriterThread extends Thread 
	{
    	private final Object lock;

	    public WriterThread(Object lock) {
    	    this.lock = lock;
	    }

    	public void run() {
        	HBF04.x = 1;
	        synchronized (lock) {
    	        lock.notifyAll();
        	}
    	}
	}

	static class NotifyThread extends Thread 
	{    
    	private final Object lock;

	    public NotifyThread(Object lock) {
        	this.lock = lock;
	    }
    
    	public void run() {
            synchronized (lock) {
                lock.notifyAll();
            }
    	}
	}

	static class ReaderThread extends Thread 
	{
    	private final Object lock;
	    
	    public ReaderThread(Object lock) {
        	this.lock = lock;
	    }

    	public void run() {
			synchronized (lock) {
		        try {
    		        lock.wait();
	    	    } catch (InterruptedException e) {}
			}
       	    System.out.println("x = " + HBF04.x);
    	}    
	}
}

