package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

import gov.nasa.jpf.vm.Verify;

// good for testing static analysis
// if there can be wait() on all paths or not 
// variants represent different scenarios

public class HBF05a 
{
    public static int x = 0;
    public static int y = 0;
    
    public static void main(String[] args) {
        Object lock = new Object();
        
        Thread t1 = new WriterThread(lock, Verify.getBoolean());
        Thread t2 = new ReaderThread(lock);

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class ReaderThread extends Thread 
	{
	    private final Object lock;

	    public ReaderThread(Object lock) {
    	    this.lock = lock;
	    }

    	public void run() {
	        System.out.println("x=" + HBF05a.x);
    	    synchronized (lock) {
        	    lock.notifyAll();
        	}
	    }
	}

	static class WriterThread extends Thread 
	{
    	protected final Object lock;
	    protected final boolean branch;

    	public WriterThread(Object l, boolean br) {
        	this.lock = l;
	        this.branch = br;
    	}

    	public void run() {
    	    try {
        	    int i1 = HBF05a.y;
            	if ( ! branch ) {
	                int i2 = HBF05a.y;
    	            int i3 = HBF05a.y;
        	        int i4 = HBF05a.y;
					synchronized (lock) {
	            	    lock.wait();
					}
                	int i5 = HBF05a.y;
	                int i6 = HBF05a.y;
    	            HBF05a.x = 1;
        	    } else {
            	    synchronized (lock) {
						lock.wait();
					}
                	HBF05a.x = 2;
            	}
	        } catch (InterruptedException e) {}
    	}
	}
}

