package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

// T1: wait L1 ; read X
// T2: wait L2 ; notify L1
// T3: notify L2
// T4: write X

public class HBF09
{
    public static int x = 0;
    
    public static void main(String[] args) {
        Object lock1 = new Object();
        Object lock2 = new Object();
        
        Thread t1 = new ReaderThread(lock1);
        Thread t2 = new FirstNotifyThread(lock1,lock2);
		Thread t3 = new SecondNotifyThread(lock2);
        Thread t4 = new WriterThread();

        t1.start();
        t2.start();
        t3.start();
		t4.start();
        
        try {
            t1.join(); 
            t2.join();
            t3.join();
			t4.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }
	
	static class ReaderThread extends Thread 
	{
    	private final Object lock1;
	    
	    public ReaderThread(Object lock1) {
        	this.lock1 = lock1;
	    }

    	public void run() {
			synchronized (lock1) {
		        try {
    		        lock1.wait();
	    	    } catch (InterruptedException e) {}
			}
       	    System.out.println("x = " + HBF09.x);
    	}    
	}

	static class FirstNotifyThread extends Thread 
	{    
    	private final Object lock1;
		private final Object lock2;

	    public FirstNotifyThread(Object lock1, Object lock2) {
        	this.lock1 = lock1;
			this.lock2 = lock2;
	    }
    
    	public void run() {
			synchronized (lock2) {
		        try {
    		        lock2.wait();
	    	    } catch (InterruptedException e) {}
			}
            synchronized (lock1) {
                lock1.notifyAll();
            }
    	}
	}

	static class SecondNotifyThread extends Thread 
	{    
		private final Object lock2;

	    public SecondNotifyThread(Object lock2) {
			this.lock2 = lock2;
	    }
    
    	public void run() {
            synchronized (lock2) {
                lock2.notifyAll();
            }
    	}
	}

	static class WriterThread extends Thread 
	{
	    public WriterThread() {
	    }

    	public void run() {
        	HBF09.x = 1;
    	}
	}
}

