package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

// T1: write X ; notify L1
// T2: wait L1 ; wait L2 ; read X
// T3: notify L2

public class HBF10
{
    public static int x = 0;
    
    public static void main(String[] args) {
        Object lock1 = new Object();
        Object lock2 = new Object();
        
        Thread t1 = new WriterThread(lock1);
        Thread t2 = new ReaderThread(lock1,lock2);
        Thread t3 = new NotifyThread(lock2);

        t1.start();
        t2.start();
        t3.start();
        
        try {
            t1.join(); 
            t2.join();
            t3.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }
	
	static class WriterThread extends Thread 
	{
    	private final Object lock1;
	    
	    public WriterThread(Object lock1) {
        	this.lock1 = lock1;
	    }

    	public void run() {
 	  		HBF10.x = 1;
 			synchronized (lock1) {
                lock1.notifyAll();
            }
    	}    
	}

	static class ReaderThread extends Thread 
	{
    	private final Object lock1;
	    private final Object lock2;
	
	    public ReaderThread(Object lock1, Object lock2) {
        	this.lock1 = lock1;
			this.lock2 = lock2;
	    }

    	public void run() {
			synchronized (lock1) {
		        try {
    		        lock1.wait();
	    	    } catch (InterruptedException e) {}
			}
			synchronized (lock2) {
		        try {
    		        lock2.wait();
	    	    } catch (InterruptedException e) {}
			}
       	    System.out.println("x = " + HBF10.x);
    	}    
	}

	static class NotifyThread extends Thread 
	{    
		private final Object lock2;

	    public NotifyThread(Object lock2) {
			this.lock2 = lock2;
	    }
    
    	public void run() {
            synchronized (lock2) {
                lock2.notifyAll();
            }
    	}
	}
}

