package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

// MAIN: start T3 ; join T3 ; start T1 ; start T2
// T1: acquire L ; write X ; write X ; release L
// T2: acquire L ; read X ; release L
// T3: write X ; read X

// Note: T3 finishes before the start of T1 and T2
// Note: we have dependency between t3.join() and the start of t1/t2 (and all events inside t1/t2)

public class HBF14
{
    public static int x = 0;

    public static void main(String[] args) {
		Object lock = new Object();
        		
        Thread t1 = new WriterThread(lock);
        Thread t2 = new ReaderThread(lock);
        Thread t3 = new InitThread();

        t3.start();

        try {
            t3.join();
        } catch (InterruptedException e) {}

        t1.start();
		t2.start();

        try {
            t1.join(); 
			t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class WriterThread extends Thread 
	{
    	private final Object lock;

	    public WriterThread(Object l) {
    	    this.lock = l;
	    }

	    public void run() {
			synchronized (lock) {
	    	    HBF14.x = 1;
				HBF14.x = 2;
			}
    	}
	}

	static class ReaderThread extends Thread 
	{
    	private final Object lock;

	    public ReaderThread(Object l) {
			this.lock = l;
	    }

    	public void run() {
			synchronized (lock) {
	        	System.out.println("x=" + HBF14.x);
			}
    	}
	}

	static class InitThread extends Thread 
	{
    	public void run() {
        	HBF14.x = 5;
			System.out.println("x=" + HBF14.x);
		}
	}
}

