package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

// MAIN: start T1 ; start T2 ; join T1 ; start T3
// T1: write X ; notify L
// T2: wait L ; read X
// T3: notify L

// Note: T1 finishes before the start of T3
// Note: we have dependency between t1.join() and the start of t3 (and all events inside t3)

public class HBF15
{
    public static int x = 0;

    public static void main(String[] args) {
		Object lock = new Object();
        		
        Thread t1 = new WriterThread(lock);
        Thread t2 = new ReaderThread(lock);
        Thread t3 = new NotifyThread(lock);

        t1.start();
		t2.start();

        try {
            t1.join(); 
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

        t3.start();

        try {
			t2.join();
            t3.join();
        } catch (InterruptedException e) {}
    }

	static class WriterThread extends Thread 
	{
    	private final Object lock;

	    public WriterThread(Object l) {
    	    this.lock = l;
	    }

	    public void run() {
	    	HBF15.x = 1;
			synchronized (lock) {
    	        lock.notifyAll();
        	}			
    	}
	}

	static class ReaderThread extends Thread 
	{
    	private final Object lock;

	    public ReaderThread(Object l) {
			this.lock = l;
	    }

    	public void run() {
			synchronized (lock) {
		        try {
    		        lock.wait();
	    	    } catch (InterruptedException e) {}
			}
	        System.out.println("x=" + HBF15.x);
    	}
	}

	static class NotifyThread extends Thread 
	{
    	private final Object lock;

	    public NotifyThread(Object l) {
    	    this.lock = l;
	    }

	    public void run() {
			synchronized (lock) {
    	        lock.notifyAll();
        	}			
    	}
	}
}

