package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

// T1: acquire L ; write X ; release L
// T2: acquire L ; read X ; release L

// Note: it uses synchronized blocks over the class object

public class HBF17
{
    public static int x = 0;
    
    public static void main(String[] args) {
        Thread t1 = new WriterThread();
        Thread t2 = new ReaderThread();

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class ReaderThread extends Thread 
	{
    	public ReaderThread() {}

	    public void run() {
    	    synchronized (HBF17.class) {
        	    System.out.println("x=" + HBF17.x);
	        }
    	}
	}

	static class WriterThread extends Thread 
	{
	    public WriterThread() {}

	    public void run() {
			synchronized (HBF17.class) {
	    	    HBF17.x = 1;
			}
    	}
	}
}

