package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

// T1: acquire L ; write X ; release L
// T2: acquire L ; read X ; release L ; read X

// Note: it uses synchronized blocks over "this"

public class HBF18
{
	public static void main(String[] args) {
        Data d = new Data();
        
        Thread t1 = new WriterThread(d);
        Thread t2 = new ReaderThread(d);

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class ReaderThread extends Thread 
	{
	    private final Data d;

    	public ReaderThread(Data d) {
        	this.d = d;
	    }

	    public void run() {
    	    System.out.println("x=" + d.getValue());
    	}
	}

	static class WriterThread extends Thread 
	{
    	private final Data d;

	    public WriterThread(Data d) {
    	    this.d = d;
	    }

	    public void run() {
    	    d.setValue(1);
    	}
	}

	static class Data
	{	
	    private int val = 0;
	    
	    public void setValue(int v)
	    {
			synchronized (this)
			{
	    		this.val = v;
			}
	    }
	    
	    public int getValue()
	    {
			int r = 0;

			synchronized (this)
			{
	    		r = this.val;
			}

			System.out.println("val="+this.val);

			return r;
	    }
	}
}

