package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

// T1: acquire L1 ; read D1 ; release L1
// T2: acquire L2 ; write D2 ; release L2 ; acquire L1 ; write D1 ; release L1

public class HBF20
{
    public static void main(String[] args) {
        Data d1 = new Data();
        Data d2 = new Data();

        Thread t1 = new ReaderThread(d1);
        Thread t2 = new WriterThread(d1,d2);

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class ReaderThread extends Thread 
	{
	    private final Data d1;

    	public ReaderThread(Data d1) {
        	this.d1 = d1;
	    }

	    public void run() {
    	    System.out.println("x=" + d1.getValue());
    	}
	}

	static class WriterThread extends Thread 
	{
    	private final Data d1;
		private final Data d2;

	    public WriterThread(Data d1, Data d2) {
    	    this.d1 = d1;
			this.d2 = d2;
	    }

	    public void run() {
    	    d2.setValue(1);
			d1.setValue(2);
    	}
	}

	static class Data
	{	
	    public int val = 0;
	    
	    public void setValue(int v)
	    {
			synchronized (this)
			{
	    		this.val = v;
			}
	    }
	    
	    public int getValue()
	    {
			synchronized (this)
			{
	    		return this.val;
			}
	    }
	}

}

