package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

// T1: acquire L1 ; read D1 ; release L1 ; read X
// T2: init D2 { write X ; write D2 } ; write X ; acquire L1 ; write D1 ; release L1

public class HBF21
{
	public static int x = 0;

    public static void main(String[] args) {
        Data d1 = new Data();

        Thread t1 = new ReaderThread(d1);
        Thread t2 = new WriterThread(d1);

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class ReaderThread extends Thread 
	{
	    private final Data d1;

    	public ReaderThread(Data d1) {
        	this.d1 = d1;
	    }

	    public void run() {
    	    System.out.println("d1=" + d1.getValue());
   	    	System.out.println("x=" + HBF21.x);
    	}
	}

	static class WriterThread extends Thread 
	{
    	private Data d1;
		private Data d2;

	    public WriterThread(Data d1) {
    	    this.d1 = d1;
	    }

	    public void run() {
			d2 = new Data(5);
			HBF21.x = 8;
    	    d1.setValue(5);
    	}
	}

	static class Data
	{	
	    public int val = 0;
	    
		public Data() {}

		public Data(int v)
		{
			HBF21.x = 4;
			this.val = v;
		}

	    public void setValue(int v)
	    {
			synchronized (this)
			{
	    		this.val = v;
			}
	    }
	    
	    public int getValue()
	    {
			synchronized (this)
			{
	    		return this.val;
			}
	    }
	}

}

