package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

// T1: acquire L ; write X ; release L
// T2: acquire L ; read X ; release L

// Note: synchronization over the common lock models the happens-before dependency between events
// Note: it uses static synchronized methods instead of synchronized blocks

public class HBF22
{
    public static void main(String[] args) {
		Thread t1 = new WriterThread();
        Thread t2 = new ReaderThread();

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class ReaderThread extends Thread 
	{
    	public ReaderThread() {
	    }

	    public void run() {
    	    System.out.println("x=" + Data.getValue());
    	}
	}

	static class WriterThread extends Thread 
	{
	    public WriterThread() {
	    }

	    public void run() {
    	    Data.setValue(1);
    	}
	}

	static class Data
	{	
	    private static int val = 0;
	    
	    public static synchronized void setValue(int v)
	    {
	    	val = v;
	    }
	    
	    public static synchronized int getValue()
	    {
	    	return val;
	    }
	}
}

