package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

// MAIN: start T1 ; start T2 ; join T1 ; join T2 ; read X
// T1: acquire L ; write X ; release L
// T2: acquire L ; read X ; release L

public class HBF23
{
    public static int x = 0;
    
    public static void main(String[] args) {
        Object lock = new Object();
        
        Thread t1 = new WriterThread(lock);
        Thread t2 = new ReaderThread(lock);

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

		System.out.println("x=" + HBF23.x);
    }

	static class ReaderThread extends Thread 
	{
	    private final Object lock;

    	public ReaderThread(Object lock) {
        	this.lock = lock;
	    }

	    public void run() {
    	    synchronized (lock) {
        	    System.out.println("x=" + HBF23.x);
	        }
    	}
	}

	static class WriterThread extends Thread 
	{
    	private final Object lock;

	    public WriterThread(Object l) {
    	    this.lock = l;
	    }

	    public void run() {
			synchronized (lock) {
	    	    HBF23.x = 1;
			}
    	}
	}
}

