package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

// T1: write X
// T2: acquire L ; read Y ; release L ; read X
// T3: acquire L ; read Y ; release L


public class HBF26 
{
    public static int x = 0;
	public static int y = 0;
    

    public static void main(String[] args) {
        Object lock = new Object();
        
        Thread t1 = new WriterThread();
        Thread t2 = new ReaderThread(lock);
        Thread t3 = new BlockerThread(lock);


        t1.start();
        t2.start();
		t3.start();
        
        try {
            t1.join(); 
            t2.join();
			t3.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class WriterThread extends Thread 
	{
	    public WriterThread() {
	    }

	    public void run() {
			int i = 'w';
	    	HBF26.x = i;
			i = 1;
    	}
	}

	static class ReaderThread extends Thread 
	{
	    private final Object lock;

    	public ReaderThread(Object lock) {
        	this.lock = lock;
	    }

	    public void run() {
    	    synchronized (lock) {
        	    System.out.println("r:y=" + HBF26.y);
	        }
		    System.out.println("r:x=" + HBF26.x);
    	}
	}

	static class BlockerThread extends Thread 
	{
	    private final Object lock;

    	public BlockerThread(Object lock) {
        	this.lock = lock;
	    }

	    public void run() {
    	    synchronized (lock) {
        	    System.out.println("b:y=" + HBF26.y);
	        }
    	}
	}

}

