package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

import java.util.ArrayList;


public class HBF27
{
	public static void main(String[] args) {
		ArrayList<Data> buffer = new ArrayList<Data>();

		Thread t1 = new WaitingThread(buffer);
		Thread t2a = new NotifierThread(buffer);
		Thread t2b = new NotifierThread(buffer);

		t1.start();
		t2a.start();
		t2b.start();
        
		try {
			t1.join();
			t2a.join();
			t2b.join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}


	static class NotifierThread extends Thread
	{
		private final ArrayList<Data> buffer;
		
		public NotifierThread(ArrayList<Data> buf) {
    	    this.buffer = buf;
    	}
		
		public void run() {
			while (true) {				
				Data d = null;
				
				synchronized (buffer) {
					if ( ! buffer.isEmpty() ) {
						d = buffer.remove(0);
					}
				}

				if (d != null) {
					synchronized (d) {
						d.notifyAll();
					}
					System.out.println("\n NT: val = " + d.val + "\n");
				}
			}
		}
	}


	static class WaitingThread extends Thread
	{
		private final ArrayList<Data> buffer;
		
		public WaitingThread(ArrayList<Data> buf) {
    	    this.buffer = buf;
    	}
		
		public void run() {
			for (int i = 0; i < 3; i++) {
				Data d1 = new Data(0);

				synchronized (buffer) {
					buffer.add(d1);
				}

				d1.val = i;

				Data d2 = null;

				synchronized (buffer) {
					if ( ! buffer.isEmpty() ) {
						d2 = buffer.get(0);
					}
				}
				
				if (d2 != null) {
					synchronized (d2) {
						try {
							d2.wait();
						}
						catch (InterruptedException e) {}
					}
				}
			}
		}
	}

	static class Data 
	{
		public int val;

		public Data(int v)
		{
			this.val = v;
		}
	}

}

