package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

// T1: m1 { wait L ; read X } ; wait L ; read X
// T2: write X ; notify L

public class HBF31
{
    public static int x = 0;
    
    public static void main(String[] args) {
		Object lock = new Object();

        Thread t1 = new ReaderThread(lock);
        Thread t2 = new WriterThread(lock);

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

    }

	static class WriterThread extends Thread
	{
    	private final Object lock;

	    public WriterThread(Object lock) {
    	    this.lock = lock;
    	}

    	public void run() {
        	HBF31.x = 1;

	        synchronized (lock) {
    	        lock.notifyAll();
        	}
    	}
	}

	static class ReaderThread extends Thread 
	{ 
    	private final Object lock;

    	public ReaderThread(Object lock) {
        	this.lock = lock;
	    }

    	public void run() {
			m1();
		
			synchronized (lock) {
	        	try {
    	        	lock.wait();
	   	    	} catch (InterruptedException e) {}
			}

			System.out.println("x_2 = " + HBF31.x);
		}

		protected void m1() {
			synchronized (lock) {
	        	try {
    	        	lock.wait();
	   	    	} catch (InterruptedException e) {}
			}

			System.out.println("x_1 = " + HBF31.x);
    	}
	}
}

