package cz.cuni.mff.d3s.stdynpor.examples.hbfield;

// T1: m1 { acquire L ; write X ; release L } ; acquire L ; write X ; release L
// T2: acquire L ; read X ; release L

// Note: synchronization over the common lock models the happens-before dependency between events
// Note: it uses synchronized methods instead of synchronized blocks

public class HBF33
{
    public static void main(String[] args) {
        Data d = new Data();
        
        Thread t1 = new WriterThread(d);
        Thread t2 = new ReaderThread(d);

        t1.start();
        t2.start();
        
        try {
            t1.join(); 
            t2.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

	static class ReaderThread extends Thread 
	{
	    private final Data d;

    	public ReaderThread(Data d) {
        	this.d = d;
	    }

	    public void run() {
    	    System.out.println("x=" + d.getValue());
    	}
	}

	static class WriterThread extends Thread 
	{
    	private final Data d;

	    public WriterThread(Data d) {
    	    this.d = d;
	    }

	    public void run() {
			m1();
 
			d.setValue(3);
		}

		public void m1() {
    	    d.setValue(1);

			int i = 5;
			System.out.println("i = " + i);
    	}
	}

	static class Data
	{	
	    private int val = 0;
	    
	    public synchronized void setValue(int v)
	    {
	    	this.val = v;
	    }
	    
	    public synchronized int getValue()
	    {
	    	return this.val;
	    }
	}
}

