package cz.cuni.mff.d3s.stdynpor.examples.trheur;

public class TRH01
{
	public static void main(String[] args)
	{
		Data d1 = new Data();
		Data d2 = new Data();
		
		Thread wt = new WriterThread(d1,d2);
		Thread rt1 = new ReaderThread(d1);
		Thread rt2 = new ReaderThread(d2);
		
		wt.start();
		rt1.start();
		rt2.start();
		
		try 
		{
			wt.join();
			rt1.join();
			rt2.join();
		} 
		catch (InterruptedException e) 
		{
			e.printStackTrace();
		}
	}

	static class ReaderThread extends Thread 
	{
		private final Data d;
		
		public ReaderThread(Data d)
		{
			this.d = d;
		}
		
		public void run()
		{
			int v = d.val;
			System.out.println("val = " + v);
		}
	}

	static class WriterThread extends Thread
	{
		private final Data d1;
		private final Data d2;
		
		public WriterThread(Data d1, Data d2)
		{
			this.d1 = d1;
			this.d2 = d2;
		}
		
		public void run()
		{
			d1.val = 1;
			d2.val = 2;
		}
	}
	
	static class Data
	{	
		public int val = 0;
	}
}

