package cz.cuni.mff.d3s.stdynpor.examples.trheur;

public class TRH05
{
	public static void main(String[] args)
	{
		int[] p1 = new int[4];
		int[] p2 = new int[4];
		int[] p3 = new int[4];

		Data d1 = new Data(10);
		Data d2 = new Data(0);
		
		Thread t1 = new PipeThread(1,p1,p2,d1,d2);
		Thread t2 = new PipeThread(2,p2,p3,d1,d2);
		Thread t3 = new PipeThread(3,p1,p3,d1,d2);

		t1.start();
		t2.start();
		t3.start();
		
		try 
		{
			t1.join();
			t2.join();
			t3.join();
		} 
		catch (InterruptedException e) 
		{
			e.printStackTrace();
		}
	}

	static class PipeThread extends Thread 
	{
		private int[] pIn;
		private int[] pOut;
		private Data dr;
		private Data dw;
		private int id;
		
		public PipeThread(int id, int[] pIn, int[] pOut, Data dr, Data dw)
		{
			this.id = id;
			this.pIn = pIn;
			this.pOut = pOut;
			this.dr = dr;
			this.dw = dw;
		}
		
		public void run() 
		{
			int v;

			dw.val++;
			
			v = pIn[0];
			System.out.println("v = " + v);
			pOut[0] = dr.val;

			v = pIn[id];
			System.out.println("v = " + v);
			pOut[id] = dr.val + 1;

			dw.val = pIn[id] + 1;
		}
	}

	static class Data
	{	
		public int val = 0;

		public Data(int v)
		{
			this.val = v;
		}
	}
	
}

