/*
 * Copyright (C) 2015, Charles University in Prague.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package cz.cuni.mff.d3s.stdynpor.data;

/**
 * Possible symbolic values: numeric constant, local variable name, field access path, complex arithmetic expression.
 */
public class SymbolicValue extends ObjectID
{
	private String value;
	
	public SymbolicValue(String valStr)
	{
		super();
		
		this.value = valStr;
	}
	
	public boolean equals(Object obj)
	{
		if (obj == null) return false;
		
		if ( ! (obj instanceof SymbolicValue) ) return false;
		
		SymbolicValue other = (SymbolicValue) obj;
		
		if ( ! this.value.equals(other.value) ) return false;
		
		return true;
	}
	
	public int hashCode()
	{
		return this.value.hashCode();
	}

	protected String createStringRepr()
	{
		return this.value;
	}
}
