/*
 * Copyright (C) 2015, Charles University in Prague.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package cz.cuni.mff.d3s.stdynpor.jpf;

import gov.nasa.jpf.Config;
import gov.nasa.jpf.JPFException; 
import gov.nasa.jpf.vm.ClassInfo;
import gov.nasa.jpf.vm.Instruction;
import gov.nasa.jpf.jvm.bytecode.InstructionFactory;


public class SharedAccessInstructionFactory extends InstructionFactory
{
	public SharedAccessInstructionFactory(Config conf)
	{
	}

	// fields
	
	@Override
	public Instruction getfield(String fieldName, String clsName, String fieldDescriptor)
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.GETFIELD(fieldName, clsName, fieldDescriptor);
	}

	@Override
	public Instruction getstatic(String fieldName, String clsName, String fieldDescriptor)
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.GETSTATIC(fieldName, clsName, fieldDescriptor);
	}
	
	@Override
	public Instruction putfield(String fieldName, String clsName, String fieldDescriptor)
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.PUTFIELD(fieldName, clsName, fieldDescriptor);
	}

	@Override
	public Instruction putstatic(String fieldName, String clsName, String fieldDescriptor)
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.PUTSTATIC(fieldName, clsName, fieldDescriptor);
	}
	
	// array elements
	
	@Override
	public Instruction aaload()
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.AALOAD();
	}
	
	@Override
	public Instruction aastore()
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.AASTORE();
	}
	
	@Override
	public Instruction baload()
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.BALOAD();
	}

	@Override
	public Instruction bastore()
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.BASTORE();
	}
	
	@Override
	public Instruction caload()
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.CALOAD();
	}

	@Override
	public Instruction castore()
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.CASTORE();
	}
	
	@Override
	public Instruction daload()
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.DALOAD();
	}

	@Override
	public Instruction dastore()
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.DASTORE();
	}
	
	@Override
	public Instruction faload()
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.FALOAD();
	}

	@Override
	public Instruction fastore()
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.FASTORE();
	}
	
	@Override
	public Instruction iaload()
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.IALOAD();
	}

	@Override
	public Instruction iastore()
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.IASTORE();
	}
	
	@Override
	public Instruction laload()
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.LALOAD();
	}

	@Override
	public Instruction lastore()
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.LASTORE();
	}
	
	@Override
	public Instruction saload()
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.SALOAD();
	}

	@Override
	public Instruction sastore()
	{
		return new cz.cuni.mff.d3s.stdynpor.jpf.bytecode.SASTORE();
	}
}
