/*
 * Copyright (C) 2015, Charles University in Prague.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package cz.cuni.mff.d3s.stdynpor.tools;

import java.util.*;
import java.io.*;


public class ResultsProcessor
{
	public static void main(String[] args)
	{
		try
		{
			String inputFileName = args[0];
			String outputFileName = args[1];
			
			List<String> statesValues = new ArrayList<String>();
			List<String> timeValues = new ArrayList<String>();

			BufferedReader inputFile = new BufferedReader(new FileReader(inputFileName));
			String line = null;
			String states1 = null;
			String states2 = null;
			String time1 = null;
			String time2 = null;
			while ( (line = inputFile.readLine()) != null )
			{
				if (line.startsWith("states:"))
				{
					int k1 = line.indexOf("new");
					int k2 = line.indexOf(',', k1+4);
					states1 = line.substring(k1+4, k2);
					
					int k3 = line.indexOf("visited");
					int k4 = line.indexOf(',', k3+8);
					states2 = line.substring(k3+8, k4);
				}
				
				if (line.startsWith("[ANALYSIS]"))
				{
					int k1 = "[ANALYSIS] time = ".length();
					int k2 = line.indexOf('s', k1+1);
					time1 = line.substring(k1, k2-1);
				}
				
				if (line.startsWith("elapsed time:"))
				{
					int k = line.indexOf('0');
					String tmpS = line.substring(k);
					String[] tmpAS = tmpS.split(":");
					int tmHour = Integer.parseInt(tmpAS[0]);
					int tmMin = Integer.parseInt(tmpAS[1]);
					int tmSec = Integer.parseInt(tmpAS[2]);
					int tm = tmHour*3600 + tmMin*60 + tmSec;										
					time2 = String.valueOf(tm);;
				}
				/*
				if (line.startsWith("[JPF]"))
				{
					int k1 = "[JPF] time = ".length();
					int k2 = line.indexOf('s', k1+1);
					time2 = line.substring(k1, k2-1);
				}
				*/
				
				if (states1 != null && states2 != null)
				{
					statesValues.add(states1 + "+" + states2);
					states1 = null;
					states2 = null;
				}
				
				if (time2 != null)
				{
					if (time1 == null) time1 = "";
					timeValues.add(time1 + "+" + time2);
					time1 = null;
					time2 = null;
				}
			}
			inputFile.close();
			
			BufferedWriter outputFile = new BufferedWriter(new FileWriter(outputFileName));
			outputFile.write("states\n");
			outputFile.write("c(");
			outputFile.write(statesValues.get(0));
			for (int i = 1; i < statesValues.size(); i++) outputFile.write(","+statesValues.get(i));
			outputFile.write(")\n");
			outputFile.write("time\n");			
			outputFile.write("c(");
			outputFile.write(timeValues.get(0));
			for (int i = 1; i < timeValues.size(); i++) outputFile.write(","+timeValues.get(i));
			outputFile.write(")\n");
			outputFile.close();			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}		
	}
}
